Package: org.codehaus.groovy.control

## [Java] Class PlaceholderVisitor

- org.codehaus.groovy.control.PlaceholderVisitor

-     public class PlaceholderVisitor
      extends ClassCodeVisitorSupport

  Marks repeated underscore placeholders used in tuple and closure parameters.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `PlaceholderVisitor(CompilationUnit compilationUnit, SourceUnit source)` Creates a visitor for placeholder analysis.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected SourceUnit` | `getSourceUnit()` Returns the source unit currently being visited.
    `` | `public static boolean` | `isPlaceholder(ASTNode node)` Checks whether the supplied node has been marked as a placeholder.
    `` | `public void` | `visitClosureExpression(ClosureExpression expression)` Visit the Closure (or Lambda) marking underscore-named parameters as placeholders
    `` | `public void` | `visitDeclarationExpression(DeclarationExpression expression)` Visit the declaration marking underscore-named variables in multi-assignments as placeholders

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSwitchExpression, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop, visitYieldStatement`

- - ### Constructor Detail

    - #### public PlaceholderVisitor(CompilationUnit compilationUnit, SourceUnit source)

      Creates a visitor for placeholder analysis.

      Parameters:
        `compilationUnit` - the owning compilation unit
        `source` - the source unit being visited

  - ### Method Detail

    - #### protected SourceUnit getSourceUnit()

      Returns the source unit currently being visited.

      Returns:
        the active source unit

    - #### public static boolean isPlaceholder(ASTNode node)

      Checks whether the supplied node has been marked as a placeholder.

      Parameters:
        `node` - the node to inspect
      Returns:
        `true` if the node is a placeholder

    - #### public void visitClosureExpression(ClosureExpression expression)

      Visit the Closure (or Lambda) marking underscore-named parameters as placeholders

      Parameters:
        `expression` - the expression to check

    - #### public void visitDeclarationExpression(DeclarationExpression expression)

      Visit the declaration marking underscore-named variables in multi-assignments as placeholders

      Parameters:
        `expression` - the expression to check